Index: uspace/srv/test/chardev-test/main.c
===================================================================
--- uspace/srv/test/chardev-test/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/test/chardev-test/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -29,5 +29,4 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <io/chardev_srv.h>
 #include <ipc/services.h>
@@ -39,18 +38,18 @@
 #define NAME  "chardev-test"
 
-static errno_t smallx_open(chardev_srvs_t *, chardev_srv_t *);
-static errno_t smallx_close(chardev_srv_t *);
-static errno_t smallx_write(chardev_srv_t *, const void *, size_t, size_t *);
-static errno_t smallx_read(chardev_srv_t *, void *, size_t, size_t *);
-
-static errno_t largex_open(chardev_srvs_t *, chardev_srv_t *);
-static errno_t largex_close(chardev_srv_t *);
-static errno_t largex_write(chardev_srv_t *, const void *, size_t, size_t *);
-static errno_t largex_read(chardev_srv_t *, void *, size_t, size_t *);
-
-static errno_t partialx_open(chardev_srvs_t *, chardev_srv_t *);
-static errno_t partialx_close(chardev_srv_t *);
-static errno_t partialx_write(chardev_srv_t *, const void *, size_t, size_t *);
-static errno_t partialx_read(chardev_srv_t *, void *, size_t, size_t *);
+static int smallx_open(chardev_srvs_t *, chardev_srv_t *);
+static int smallx_close(chardev_srv_t *);
+static int smallx_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int smallx_read(chardev_srv_t *, void *, size_t, size_t *);
+
+static int largex_open(chardev_srvs_t *, chardev_srv_t *);
+static int largex_close(chardev_srv_t *);
+static int largex_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int largex_read(chardev_srv_t *, void *, size_t, size_t *);
+
+static int partialx_open(chardev_srvs_t *, chardev_srv_t *);
+static int partialx_close(chardev_srv_t *);
+static int partialx_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int partialx_read(chardev_srv_t *, void *, size_t, size_t *);
 
 static service_id_t smallx_svc_id;
@@ -106,5 +105,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	printf("%s: Character device test service\n", NAME);
@@ -113,5 +112,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		printf("%s: Failed registering server.: %s\n", NAME, str_error(rc));
+		printf("%s: Failed registering server. (%d)\n", NAME, rc);
 		return rc;
 	}
@@ -131,5 +130,5 @@
 	rc = loc_service_register(SERVICE_NAME_CHARDEV_TEST_SMALLX, &smallx_svc_id);
 	if (rc != EOK) {
-		printf("%s: Failed registering service.: %s\n", NAME, str_error(rc));
+		printf("%s: Failed registering service. (%d)\n", NAME, rc);
 		return rc;
 	}
@@ -137,5 +136,5 @@
 	rc = loc_service_register(SERVICE_NAME_CHARDEV_TEST_LARGEX, &largex_svc_id);
 	if (rc != EOK) {
-		printf("%s: Failed registering service.: %s\n", NAME, str_error(rc));
+		printf("%s: Failed registering service. (%d)\n", NAME, rc);
 		return rc;
 	}
@@ -143,5 +142,5 @@
 	rc = loc_service_register(SERVICE_NAME_CHARDEV_TEST_PARTIALX, &partialx_svc_id);
 	if (rc != EOK) {
-		printf("%s: Failed registering service.: %s\n", NAME, str_error(rc));
+		printf("%s: Failed registering service. (%d)\n", NAME, rc);
 		return rc;
 	}
@@ -156,15 +155,15 @@
 }
 
-static errno_t smallx_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
-{
-	return EOK;
-}
-
-static errno_t smallx_close(chardev_srv_t *srv)
-{
-	return EOK;
-}
-
-static errno_t smallx_write(chardev_srv_t *srv, const void *data, size_t size,
+static int smallx_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int smallx_close(chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int smallx_write(chardev_srv_t *srv, const void *data, size_t size,
     size_t *nwritten)
 {
@@ -178,5 +177,5 @@
 }
 
-static errno_t smallx_read(chardev_srv_t *srv, void *buf, size_t size,
+static int smallx_read(chardev_srv_t *srv, void *buf, size_t size,
     size_t *nread)
 {
@@ -191,15 +190,15 @@
 }
 
-static errno_t largex_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
-{
-	return EOK;
-}
-
-static errno_t largex_close(chardev_srv_t *srv)
-{
-	return EOK;
-}
-
-static errno_t largex_write(chardev_srv_t *srv, const void *data, size_t size,
+static int largex_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int largex_close(chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int largex_write(chardev_srv_t *srv, const void *data, size_t size,
     size_t *nwritten)
 {
@@ -213,5 +212,5 @@
 }
 
-static errno_t largex_read(chardev_srv_t *srv, void *buf, size_t size,
+static int largex_read(chardev_srv_t *srv, void *buf, size_t size,
     size_t *nread)
 {
@@ -226,15 +225,15 @@
 }
 
-static errno_t partialx_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
-{
-	return EOK;
-}
-
-static errno_t partialx_close(chardev_srv_t *srv)
-{
-	return EOK;
-}
-
-static errno_t partialx_write(chardev_srv_t *srv, const void *data, size_t size,
+static int partialx_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int partialx_close(chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int partialx_write(chardev_srv_t *srv, const void *data, size_t size,
     size_t *nwritten)
 {
@@ -248,5 +247,5 @@
 }
 
-static errno_t partialx_read(chardev_srv_t *srv, void *buf, size_t size,
+static int partialx_read(chardev_srv_t *srv, void *buf, size_t size,
     size_t *nread)
 {
Index: uspace/srv/vfs/vfs.c
===================================================================
--- uspace/srv/vfs/vfs.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/vfs/vfs.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,5 +44,4 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <stdio.h>
 #include <stdbool.h>
@@ -88,5 +87,5 @@
 int main(int argc, char **argv)
 {
-	errno_t rc;
+	int rc;
 
 	printf("%s: HelenOS VFS server\n", NAME);
@@ -123,9 +122,7 @@
 	port_id_t port;
 	rc = async_create_port(INTERFACE_PAGER, vfs_pager, NULL, &port);
-	if (rc != EOK) {
-		printf("%s: Cannot create pager port: %s\n", NAME, str_error(rc));
+	if (rc != EOK)
 		return rc;
-	}
-
+		
 	/*
 	 * Set a connection handling function/fibril.
@@ -144,5 +141,5 @@
 	rc = service_register(SERVICE_VFS);
 	if (rc != EOK) {
-		printf("%s: Cannot register VFS service: %s\n", NAME, str_error(rc));
+		printf("%s: Cannot register VFS service\n", NAME);
 		return rc;
 	}
Index: uspace/srv/vfs/vfs.h
===================================================================
--- uspace/srv/vfs/vfs.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/vfs/vfs.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -176,8 +176,8 @@
 extern fs_handle_t fs_name_to_handle(unsigned int instance, const char *, bool);
 extern vfs_info_t *fs_handle_to_info(fs_handle_t);
-extern errno_t vfs_get_fstypes(vfs_fstypes_t *);
-
-extern errno_t vfs_lookup_internal(vfs_node_t *, char *, int, vfs_lookup_res_t *);
-extern errno_t vfs_link_internal(vfs_node_t *, char *, vfs_triplet_t *);
+extern int vfs_get_fstypes(vfs_fstypes_t *);
+
+extern int vfs_lookup_internal(vfs_node_t *, char *, int, vfs_lookup_res_t *);
+extern int vfs_link_internal(vfs_node_t *, char *, vfs_triplet_t *);
 
 extern bool vfs_nodes_init(void);
@@ -194,33 +194,33 @@
 
 extern void vfs_op_pass_handle(task_id_t, task_id_t, int);
-extern errno_t vfs_wait_handle_internal(bool, int *);
+extern int vfs_wait_handle_internal(bool);
 
 extern vfs_file_t *vfs_file_get(int);
 extern void vfs_file_put(vfs_file_t *);
-extern errno_t vfs_fd_assign(vfs_file_t *, int);
-extern errno_t vfs_fd_alloc(vfs_file_t **file, bool desc, int *);
-extern errno_t vfs_fd_free(int);
+extern int vfs_fd_assign(vfs_file_t *, int);
+extern int vfs_fd_alloc(vfs_file_t **file, bool desc);
+extern int vfs_fd_free(int);
 
 extern void vfs_node_addref(vfs_node_t *);
 extern void vfs_node_delref(vfs_node_t *);
-extern errno_t vfs_open_node_remote(vfs_node_t *);
-
-extern errno_t vfs_op_clone(int oldfd, int newfd, bool desc, int *);
-extern errno_t vfs_op_fsprobe(const char *, service_id_t, vfs_fs_probe_info_t *);
-extern errno_t vfs_op_mount(int mpfd, unsigned servid, unsigned flags, unsigned instance, const char *opts, const char *fsname, int *outfd);
-extern errno_t vfs_op_mtab_get(void);
-extern errno_t vfs_op_open(int fd, int flags);
-extern errno_t vfs_op_put(int fd);
-extern errno_t vfs_op_read(int fd, aoff64_t, size_t *out_bytes);
-extern errno_t vfs_op_rename(int basefd, char *old, char *new);
-extern errno_t vfs_op_resize(int fd, int64_t size);
-extern errno_t vfs_op_stat(int fd);
-extern errno_t vfs_op_statfs(int fd);
-extern errno_t vfs_op_sync(int fd);
-extern errno_t vfs_op_unlink(int parentfd, int expectfd, char *path);
-extern errno_t vfs_op_unmount(int mpfd);
-extern errno_t vfs_op_wait_handle(bool high_fd, int *out_fd);
-extern errno_t vfs_op_walk(int parentfd, int flags, char *path, int *out_fd);
-extern errno_t vfs_op_write(int fd, aoff64_t, size_t *out_bytes);
+extern int vfs_open_node_remote(vfs_node_t *);
+
+extern int vfs_op_clone(int oldfd, int newfd, bool desc);
+extern int vfs_op_fsprobe(const char *, service_id_t, vfs_fs_probe_info_t *);
+extern int vfs_op_mount(int mpfd, unsigned servid, unsigned flags, unsigned instance, const char *opts, const char *fsname, int *outfd);
+extern int vfs_op_mtab_get(void);
+extern int vfs_op_open(int fd, int flags);
+extern int vfs_op_put(int fd);
+extern int vfs_op_read(int fd, aoff64_t, size_t *out_bytes);
+extern int vfs_op_rename(int basefd, char *old, char *new);
+extern int vfs_op_resize(int fd, int64_t size);
+extern int vfs_op_stat(int fd);
+extern int vfs_op_statfs(int fd);
+extern int vfs_op_sync(int fd);
+extern int vfs_op_unlink(int parentfd, int expectfd, char *path);
+extern int vfs_op_unmount(int mpfd);
+extern int vfs_op_wait_handle(bool high_fd);
+extern int vfs_op_walk(int parentfd, int flags, char *path, int *out_fd);
+extern int vfs_op_write(int fd, aoff64_t, size_t *out_bytes);
 
 extern void vfs_register(ipc_callid_t, ipc_call_t *);
@@ -233,5 +233,5 @@
 } rdwr_io_chunk_t;
 
-extern errno_t vfs_rdwr_internal(int, aoff64_t, bool, rdwr_io_chunk_t *);
+extern int vfs_rdwr_internal(int, aoff64_t, bool, rdwr_io_chunk_t *);
 
 extern void vfs_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg);
Index: uspace/srv/vfs/vfs_file.c
===================================================================
--- uspace/srv/vfs/vfs_file.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/vfs/vfs_file.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -64,5 +64,5 @@
 } vfs_boxed_handle_t;
 
-static errno_t _vfs_fd_free(vfs_client_data_t *, int);
+static int _vfs_fd_free(vfs_client_data_t *, int);
 
 /** Initialize the table of open files. */
@@ -133,5 +133,5 @@
 
 /** Close the file in the endpoint FS server. */
-static errno_t vfs_file_close_remote(vfs_file_t *file)
+static int vfs_file_close_remote(vfs_file_t *file)
 {
 	assert(!file->refcnt);
@@ -145,8 +145,8 @@
 	vfs_exchange_release(exch);
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(msg, &rc);
 	
-	return IPC_GET_RETVAL(answer);
+	return IPC_GET_ARG1(answer);
 }
 
@@ -168,7 +168,7 @@
  *			decremented.
  */
-static errno_t vfs_file_delref(vfs_client_data_t *vfs_data, vfs_file_t *file)
-{
-	errno_t rc = EOK;
+static int vfs_file_delref(vfs_client_data_t *vfs_data, vfs_file_t *file)
+{
+	int rc = EOK;
 
 	assert(fibril_mutex_is_locked(&vfs_data->lock));
@@ -192,5 +192,5 @@
 }
 
-static errno_t _vfs_fd_alloc(vfs_client_data_t *vfs_data, vfs_file_t **file, bool desc, int *out_fd)
+static int _vfs_fd_alloc(vfs_client_data_t *vfs_data, vfs_file_t **file, bool desc)
 {
 	if (!vfs_files_init(vfs_data))
@@ -223,6 +223,5 @@
 			
 			fibril_mutex_unlock(&vfs_data->lock);
-			*out_fd = (int) i;
-			return EOK;
+			return (int) i;
 		}
 		
@@ -250,14 +249,13 @@
  *             in a descending order.
  *
- * @param[out] out_fd  First available file descriptor
- *
- * @return Error code.
- */
-errno_t vfs_fd_alloc(vfs_file_t **file, bool desc, int *out_fd)
-{
-	return _vfs_fd_alloc(VFS_DATA, file, desc, out_fd);
-}
-
-static errno_t _vfs_fd_free_locked(vfs_client_data_t *vfs_data, int fd)
+ * @return First available file descriptor or a negative error
+ *         code.
+ */
+int vfs_fd_alloc(vfs_file_t **file, bool desc)
+{
+	return _vfs_fd_alloc(VFS_DATA, file, desc);
+}
+
+static int _vfs_fd_free_locked(vfs_client_data_t *vfs_data, int fd)
 {
 	if ((fd < 0) || (fd >= MAX_OPEN_FILES) || !vfs_data->files[fd]) {
@@ -265,12 +263,12 @@
 	}
 
-	errno_t rc = vfs_file_delref(vfs_data, vfs_data->files[fd]);
+	int rc = vfs_file_delref(vfs_data, vfs_data->files[fd]);
 	vfs_data->files[fd] = NULL;
 	return rc;
 }
 
-static errno_t _vfs_fd_free(vfs_client_data_t *vfs_data, int fd)
-{
-	errno_t rc;
+static int _vfs_fd_free(vfs_client_data_t *vfs_data, int fd)
+{
+	int rc;
 
 	if (!vfs_files_init(vfs_data))
@@ -291,5 +289,5 @@
  *			descriptor.
  */
-errno_t vfs_fd_free(int fd)
+int vfs_fd_free(int fd)
 {
 	return _vfs_fd_free(VFS_DATA, fd);
@@ -305,5 +303,5 @@
  *
  */
-errno_t vfs_fd_assign(vfs_file_t *file, int fd)
+int vfs_fd_assign(vfs_file_t *file, int fd)
 {
 	if (!vfs_files_init(VFS_DATA))
@@ -429,5 +427,5 @@
 }
 
-errno_t vfs_wait_handle_internal(bool high_fd, int *out_fd)
+int vfs_wait_handle_internal(bool high_fd)
 {
 	vfs_client_data_t *vfs_data = VFS_DATA;	
@@ -443,9 +441,9 @@
 
 	vfs_file_t *file;
-	errno_t rc = _vfs_fd_alloc(vfs_data, &file, high_fd, out_fd);
-	if (rc != EOK) {
+	int fd = _vfs_fd_alloc(vfs_data, &file, high_fd);
+	if (fd < 0) {
 		vfs_node_delref(bh->node);
 		free(bh);
-		return rc;
+		return fd;
 	}
 	
@@ -454,5 +452,5 @@
 	vfs_file_put(file);
 	free(bh);
-	return EOK;
+	return fd;
 }
 
Index: uspace/srv/vfs/vfs_ipc.c
===================================================================
--- uspace/srv/vfs/vfs_ipc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/vfs/vfs_ipc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,7 +41,6 @@
 	bool desc = IPC_GET_ARG3(*request);
 	
-	int outfd = -1;
-	errno_t rc = vfs_op_clone(oldfd, newfd, desc, &outfd);
-	async_answer_1(rid, rc, outfd);
+	int ret = vfs_op_clone(oldfd, newfd, desc);
+	async_answer_0(rid, ret);
 }
 
@@ -53,5 +52,5 @@
 	vfs_fs_probe_info_t info;
 	size_t len;
-	errno_t rc;
+	int rc;
 	
 	/*
@@ -88,5 +87,5 @@
 	size_t len;
 	vfs_fstypes_t fstypes;
-	errno_t rc;
+	int rc;
 
 	rc = vfs_get_fstypes(&fstypes);
@@ -129,5 +128,5 @@
 	
 	/* Now we expect to receive the mount options. */
-	errno_t rc = async_data_write_accept((void **) &opts, true, 0,
+	int rc = async_data_write_accept((void **) &opts, true, 0,
 	    MAX_MNTOPTS_LEN, 0, NULL);
 	if (rc != EOK) {
@@ -161,5 +160,5 @@
 	int mode = IPC_GET_ARG2(*request);
 
-	errno_t rc = vfs_op_open(fd, mode);
+	int rc = vfs_op_open(fd, mode);
 	async_answer_0(rid, rc);
 }
@@ -168,5 +167,5 @@
 {
 	int fd = IPC_GET_ARG1(*request);
-	errno_t rc = vfs_op_put(fd);
+	int rc = vfs_op_put(fd);
 	async_answer_0(rid, rc);
 }
@@ -179,5 +178,5 @@
 
 	size_t bytes = 0;
-	errno_t rc = vfs_op_read(fd, pos, &bytes);
+	int rc = vfs_op_read(fd, pos, &bytes);
 	async_answer_1(rid, rc, bytes);
 }
@@ -189,5 +188,5 @@
 	char *old = NULL;
 	char *new = NULL;
-	errno_t rc;
+	int rc;
 	
 	basefd = IPC_GET_ARG1(*request);
@@ -231,5 +230,5 @@
 	int fd = IPC_GET_ARG1(*request);
 	int64_t size = MERGE_LOUP32(IPC_GET_ARG2(*request), IPC_GET_ARG3(*request));
-	errno_t rc = vfs_op_resize(fd, size);
+	int rc = vfs_op_resize(fd, size);
 	async_answer_0(rid, rc);
 }
@@ -238,5 +237,5 @@
 {
 	int fd = IPC_GET_ARG1(*request);
-	errno_t rc = vfs_op_stat(fd);
+	int rc = vfs_op_stat(fd);
 	async_answer_0(rid, rc);
 }
@@ -246,5 +245,5 @@
 	int fd = (int) IPC_GET_ARG1(*request);
 	
-	errno_t rc = vfs_op_statfs(fd);
+	int rc = vfs_op_statfs(fd);
 	async_answer_0(rid, rc);
 }
@@ -253,5 +252,5 @@
 {
 	int fd = IPC_GET_ARG1(*request);
-	errno_t rc = vfs_op_sync(fd);
+	int rc = vfs_op_sync(fd);
 	async_answer_0(rid, rc);
 }
@@ -263,5 +262,5 @@
 	
 	char *path;
-	errno_t rc = async_data_write_accept((void **) &path, true, 0, 0, 0, NULL);
+	int rc = async_data_write_accept((void **) &path, true, 0, 0, 0, NULL);
 	if (rc == EOK)
 		rc = vfs_op_unlink(parentfd, expectfd, path);
@@ -273,5 +272,5 @@
 {
 	int mpfd = IPC_GET_ARG1(*request);
-	errno_t rc = vfs_op_unmount(mpfd);
+	int rc = vfs_op_unmount(mpfd);
 	async_answer_0(rid, rc);
 }
@@ -280,7 +279,6 @@
 {
 	bool high_fd = IPC_GET_ARG1(*request);
-	int fd = -1;
-	errno_t rc = vfs_op_wait_handle(high_fd, &fd);
-	async_answer_1(rid, rc, fd);
+	int fd = vfs_op_wait_handle(high_fd);
+	async_answer_1(rid, EOK, fd);
 }
 
@@ -296,5 +294,5 @@
 	int fd = 0;
 	char *path;
-	errno_t rc = async_data_write_accept((void **)&path, true, 0, 0, 0, NULL);
+	int rc = async_data_write_accept((void **)&path, true, 0, 0, 0, NULL);
 	if (rc == EOK) {
 		rc = vfs_op_walk(parentfd, flags, path, &fd);
@@ -311,5 +309,5 @@
 
 	size_t bytes = 0;
-	errno_t rc = vfs_op_write(fd, pos, &bytes);
+	int rc = vfs_op_write(fd, pos, &bytes);
 	async_answer_1(rid, rc, bytes);
 }
Index: uspace/srv/vfs/vfs_lookup.c
===================================================================
--- uspace/srv/vfs/vfs_lookup.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/vfs/vfs_lookup.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,5 +53,5 @@
 uint8_t *plb = NULL;
 
-static errno_t plb_insert_entry(plb_entry_t *entry, char *path, size_t *start,
+static int plb_insert_entry(plb_entry_t *entry, char *path, size_t *start,
     size_t len)
 {
@@ -138,5 +138,5 @@
 }
 
-errno_t vfs_link_internal(vfs_node_t *base, char *path, vfs_triplet_t *child)
+int vfs_link_internal(vfs_node_t *base, char *path, vfs_triplet_t *child)
 {
 	assert(base != NULL);
@@ -148,5 +148,5 @@
 	vfs_lookup_res_t res;
 	char component[NAME_MAX + 1];
-	errno_t rc;
+	int rc;
 	
 	size_t len;
@@ -197,5 +197,5 @@
 	
 	rc = async_data_write_start(exch, component, str_size(component) + 1);
-	errno_t orig_rc;
+	sysarg_t orig_rc;
 	async_wait_for(req, &orig_rc);
 	vfs_exchange_release(exch);
@@ -207,5 +207,5 @@
 }
 
-static errno_t out_lookup(vfs_triplet_t *base, size_t *pfirst, size_t *plen,
+static int out_lookup(vfs_triplet_t *base, size_t *pfirst, size_t *plen,
     int lflag, vfs_lookup_res_t *result)
 {
@@ -213,5 +213,5 @@
 	assert(result);
 	
-	errno_t rc;
+	sysarg_t rc;
 	ipc_call_t answer;
 	async_exch_t *exch = vfs_exchange_grab(base->fs_handle);
@@ -222,6 +222,6 @@
 	vfs_exchange_release(exch);
 	
-	if (rc != EOK)
-		return rc;
+	if ((int) rc < 0)
+		return (int) rc;
 	
 	unsigned last = *pfirst + *plen;
@@ -229,6 +229,6 @@
 	*plen = last - *pfirst;
 	
-	result->triplet.fs_handle = (fs_handle_t) IPC_GET_ARG1(answer);
-	result->triplet.service_id = base->service_id;
+	result->triplet.fs_handle = (fs_handle_t) rc;
+	result->triplet.service_id = (service_id_t) IPC_GET_ARG1(answer);
 	result->triplet.index = (fs_index_t) IPC_GET_ARG2(answer);
 	result->size = MERGE_LOUP32(IPC_GET_ARG4(answer), IPC_GET_ARG5(answer));
@@ -238,9 +238,9 @@
 }
 
-static errno_t _vfs_lookup_internal(vfs_node_t *base, char *path, int lflag,
+static int _vfs_lookup_internal(vfs_node_t *base, char *path, int lflag,
     vfs_lookup_res_t *result, size_t len)
 {
 	size_t first;
-	errno_t rc;
+	int rc;
 
 	plb_entry_t entry;
@@ -334,5 +334,5 @@
  *
  */
-errno_t vfs_lookup_internal(vfs_node_t *base, char *path, int lflag,
+int vfs_lookup_internal(vfs_node_t *base, char *path, int lflag,
     vfs_lookup_res_t *result)
 {
@@ -341,5 +341,5 @@
 	
 	size_t len;
-	errno_t rc;
+	int rc;
 	char *npath = canonify(path, &len);
 	if (!npath) {
Index: uspace/srv/vfs/vfs_node.c
===================================================================
--- uspace/srv/vfs/vfs_node.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/vfs/vfs_node.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -265,5 +265,5 @@
  *
  */
-errno_t vfs_open_node_remote(vfs_node_t *node)
+int vfs_open_node_remote(vfs_node_t *node)
 {
 	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
@@ -275,5 +275,5 @@
 	vfs_exchange_release(exch);
 
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(req, &rc);
 	
@@ -318,5 +318,5 @@
 {
 	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
-	errno_t rc = async_req_2_0(exch, VFS_OUT_IS_EMPTY, node->service_id,
+	int rc = async_req_2_0(exch, VFS_OUT_IS_EMPTY, node->service_id,
 	    node->index);
 	vfs_exchange_release(exch);
Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/vfs/vfs_ops.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,5 +52,5 @@
 
 /* Forward declarations of static functions. */
-static errno_t vfs_truncate_internal(fs_handle_t, service_id_t, fs_index_t,
+static int vfs_truncate_internal(fs_handle_t, service_id_t, fs_index_t,
     aoff64_t);
 
@@ -86,7 +86,7 @@
 }
 
-errno_t vfs_op_clone(int oldfd, int newfd, bool desc, int *out_fd)
-{
-	errno_t rc;
+int vfs_op_clone(int oldfd, int newfd, bool desc)
+{
+	int rc;
 
 	/* If the file descriptors are the same, do nothing. */
@@ -104,9 +104,8 @@
 		/* Assign the old file to newfd. */
 		rc = vfs_fd_assign(oldfile, newfd);
-		*out_fd = newfd;
 	} else {
 		vfs_file_t *newfile;
-		rc = vfs_fd_alloc(&newfile, desc, out_fd);
-		if (rc == EOK) {
+		int newfd = vfs_fd_alloc(&newfile, desc);
+		if (newfd >= 0) {
 			newfile->node = oldfile->node;
 			newfile->permissions = oldfile->permissions;
@@ -115,4 +114,5 @@
 			vfs_file_put(newfile);
 		}
+		rc = newfd;
 	}
 	vfs_file_put(oldfile);
@@ -121,10 +121,10 @@
 }
 
-errno_t vfs_op_put(int fd)
+int vfs_op_put(int fd)
 {
 	return vfs_fd_free(fd);
 }
 
-static errno_t vfs_connect_internal(service_id_t service_id, unsigned flags,
+static int vfs_connect_internal(service_id_t service_id, unsigned flags,
     unsigned instance, const char *options, const char *fsname,
     vfs_node_t **root)
@@ -152,5 +152,5 @@
 	    &answer);
 	/* Send the mount options */
-	errno_t rc = async_data_write_start(exch, options, str_size(options));
+	sysarg_t rc = async_data_write_start(exch, options, str_size(options));
 	if (rc != EOK) {
 		async_forget(msg);
@@ -188,10 +188,10 @@
 }
 
-errno_t vfs_op_fsprobe(const char *fs_name, service_id_t sid,
+int vfs_op_fsprobe(const char *fs_name, service_id_t sid,
     vfs_fs_probe_info_t *info)
 {
 	fs_handle_t fs_handle = 0;
-	errno_t rc;
-	errno_t retval;
+	sysarg_t rc;
+	int retval;
 	
 	fibril_mutex_lock(&fs_list_lock);
@@ -222,11 +222,11 @@
 }
 
-errno_t vfs_op_mount(int mpfd, unsigned service_id, unsigned flags,
-    unsigned instance, const char *opts, const char *fs_name, int *out_fd)
-{
-	errno_t rc;
+int vfs_op_mount(int mpfd, unsigned service_id, unsigned flags,
+    unsigned instance, const char *opts, const char *fs_name, int *outfd)
+{
+	int rc;
 	vfs_file_t *mp = NULL;
 	vfs_file_t *file = NULL;
-	*out_fd = -1;
+	int fd = -1;
 	
 	if (!(flags & VFS_MOUNT_CONNECT_ONLY)) {
@@ -254,6 +254,7 @@
 	
 	if (!(flags & VFS_MOUNT_NO_REF)) {
-		rc = vfs_fd_alloc(&file, false, out_fd);
-		if (rc != EOK) {
+		fd = vfs_fd_alloc(&file, false);
+		if (fd < 0) {
+			rc = fd;
 			goto out;
 		}
@@ -294,13 +295,14 @@
 		vfs_file_put(file);
 
-	if (rc != EOK && *out_fd >= 0) {
-		vfs_fd_free(*out_fd);
-		*out_fd = -1;
-	}
-	
+	if (rc != EOK && fd >= 0) {
+		vfs_fd_free(fd);
+		fd = 0;
+	}
+	
+	*outfd = fd;
 	return rc;
 }
 
-errno_t vfs_op_open(int fd, int mode)
+int vfs_op_open(int fd, int mode)
 {
 	if (mode == 0)
@@ -336,5 +338,5 @@
 	}
 	
-	errno_t rc = vfs_open_node_remote(file->node);
+	int rc = vfs_open_node_remote(file->node);
 	if (rc != EOK) {
 		file->open_read = file->open_write = false;
@@ -347,12 +349,12 @@
 }
 
-typedef errno_t (* rdwr_ipc_cb_t)(async_exch_t *, vfs_file_t *, aoff64_t,
+typedef int (* rdwr_ipc_cb_t)(async_exch_t *, vfs_file_t *, aoff64_t,
     ipc_call_t *, bool, void *);
 
-static errno_t rdwr_ipc_client(async_exch_t *exch, vfs_file_t *file, aoff64_t pos,
+static int rdwr_ipc_client(async_exch_t *exch, vfs_file_t *file, aoff64_t pos,
     ipc_call_t *answer, bool read, void *data)
 {
 	size_t *bytes = (size_t *) data;
-	errno_t rc;
+	int rc;
 
 	/*
@@ -378,5 +380,5 @@
 }
 
-static errno_t rdwr_ipc_internal(async_exch_t *exch, vfs_file_t *file, aoff64_t pos,
+static int rdwr_ipc_internal(async_exch_t *exch, vfs_file_t *file, aoff64_t pos,
     ipc_call_t *answer, bool read, void *data)
 {
@@ -392,5 +394,5 @@
 		return EINVAL;
 
-	errno_t retval = async_data_read_start(exch, chunk->buffer, chunk->size);
+	int retval = async_data_read_start(exch, chunk->buffer, chunk->size);
 	if (retval != EOK) {
 		async_forget(msg);
@@ -398,13 +400,13 @@
 	}
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(msg, &rc);
 	
 	chunk->size = IPC_GET_ARG1(*answer); 
 
-	return (errno_t) rc;
-}
-
-static errno_t vfs_rdwr(int fd, aoff64_t pos, bool read, rdwr_ipc_cb_t ipc_cb,
+	return (int) rc;
+}
+
+static int vfs_rdwr(int fd, aoff64_t pos, bool read, rdwr_ipc_cb_t ipc_cb,
     void *ipc_cb_data)
 {
@@ -475,5 +477,5 @@
 	 */
 	ipc_call_t answer;
-	errno_t rc = ipc_cb(fs_exch, file, pos, &answer, read, ipc_cb_data);
+	int rc = ipc_cb(fs_exch, file, pos, &answer, read, ipc_cb_data);
 	
 	vfs_exchange_release(fs_exch);
@@ -499,15 +501,15 @@
 }
 
-errno_t vfs_rdwr_internal(int fd, aoff64_t pos, bool read, rdwr_io_chunk_t *chunk)
+int vfs_rdwr_internal(int fd, aoff64_t pos, bool read, rdwr_io_chunk_t *chunk)
 {
 	return vfs_rdwr(fd, pos, read, rdwr_ipc_internal, chunk);
 }
 
-errno_t vfs_op_read(int fd, aoff64_t pos, size_t *out_bytes)
+int vfs_op_read(int fd, aoff64_t pos, size_t *out_bytes)
 {
 	return vfs_rdwr(fd, pos, true, rdwr_ipc_client, out_bytes);
 }
 
-errno_t vfs_op_rename(int basefd, char *old, char *new)
+int vfs_op_rename(int basefd, char *old, char *new)
 {
 	vfs_file_t *base_file = vfs_file_get(basefd);
@@ -524,5 +526,5 @@
 	bool orig_unlinked = false;
 	
-	errno_t rc;
+	int rc;
 	
 	size_t shared = shared_path(old, new);
@@ -610,5 +612,5 @@
 }
 
-errno_t vfs_op_resize(int fd, int64_t size)
+int vfs_op_resize(int fd, int64_t size)
 {
 	vfs_file_t *file = vfs_file_get(fd);
@@ -618,5 +620,5 @@
 	fibril_rwlock_write_lock(&file->node->contents_rwlock);
 	
-	errno_t rc = vfs_truncate_internal(file->node->fs_handle,
+	int rc = vfs_truncate_internal(file->node->fs_handle,
 	    file->node->service_id, file->node->index, size);
 	if (rc == EOK)
@@ -628,5 +630,5 @@
 }
 
-errno_t vfs_op_stat(int fd)
+int vfs_op_stat(int fd)
 {
 	vfs_file_t *file = vfs_file_get(fd);
@@ -637,5 +639,5 @@
 
 	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
-	errno_t rc = async_data_read_forward_fast(exch, VFS_OUT_STAT,
+	int rc = async_data_read_forward_fast(exch, VFS_OUT_STAT,
 	    node->service_id, node->index, true, 0, NULL);
 	vfs_exchange_release(exch);
@@ -645,5 +647,5 @@
 }
 
-errno_t vfs_op_statfs(int fd)
+int vfs_op_statfs(int fd)
 {
 	vfs_file_t *file = vfs_file_get(fd);
@@ -654,5 +656,5 @@
 
 	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
-	errno_t rc = async_data_read_forward_fast(exch, VFS_OUT_STATFS,
+	int rc = async_data_read_forward_fast(exch, VFS_OUT_STATFS,
 	    node->service_id, node->index, false, 0, NULL);
 	vfs_exchange_release(exch);
@@ -662,5 +664,5 @@
 }
 
-errno_t vfs_op_sync(int fd)
+int vfs_op_sync(int fd)
 {
 	vfs_file_t *file = vfs_file_get(fd);
@@ -677,5 +679,5 @@
 	vfs_exchange_release(fs_exch);
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(msg, &rc);
 	
@@ -685,19 +687,19 @@
 }
 
-static errno_t vfs_truncate_internal(fs_handle_t fs_handle, service_id_t service_id,
+static int vfs_truncate_internal(fs_handle_t fs_handle, service_id_t service_id,
     fs_index_t index, aoff64_t size)
 {
 	async_exch_t *exch = vfs_exchange_grab(fs_handle);
-	errno_t rc = async_req_4_0(exch, VFS_OUT_TRUNCATE,
+	sysarg_t rc = async_req_4_0(exch, VFS_OUT_TRUNCATE,
 	    (sysarg_t) service_id, (sysarg_t) index, LOWER32(size),
 	    UPPER32(size));
 	vfs_exchange_release(exch);
 	
-	return (errno_t) rc;
-}
-
-errno_t vfs_op_unlink(int parentfd, int expectfd, char *path)
-{
-	errno_t rc = EOK;
+	return (int) rc;
+}
+
+int vfs_op_unlink(int parentfd, int expectfd, char *path)
+{
+	int rc = EOK;
 	vfs_file_t *parent = NULL;
 	vfs_file_t *expect = NULL;
@@ -778,5 +780,5 @@
 }
 
-errno_t vfs_op_unmount(int mpfd)
+int vfs_op_unmount(int mpfd)
 {
 	vfs_file_t *mp = vfs_file_get(mpfd);
@@ -806,5 +808,5 @@
 	
 	async_exch_t *exch = vfs_exchange_grab(mp->node->mount->fs_handle);
-	errno_t rc = async_req_1_0(exch, VFS_OUT_UNMOUNTED,
+	int rc = async_req_1_0(exch, VFS_OUT_UNMOUNTED,
 	    mp->node->mount->service_id);
 	vfs_exchange_release(exch);
@@ -826,7 +828,7 @@
 }
 
-errno_t vfs_op_wait_handle(bool high_fd, int *out_fd)
-{
-	return vfs_wait_handle_internal(high_fd, out_fd);
+int vfs_op_wait_handle(bool high_fd)
+{
+	return vfs_wait_handle_internal(high_fd);
 }
 
@@ -862,5 +864,5 @@
 }
 
-errno_t vfs_op_walk(int parentfd, int flags, char *path, int *out_fd)
+int vfs_op_walk(int parentfd, int flags, char *path, int *out_fd)
 {
 	if (!walk_flags_valid(flags))
@@ -874,5 +876,5 @@
 	
 	vfs_lookup_res_t lr;
-	errno_t rc = vfs_lookup_internal(parent->node, path,
+	int rc = vfs_lookup_internal(parent->node, path,
 	    walk_lookup_flags(flags), &lr);
 	if (rc != EOK) {
@@ -890,9 +892,9 @@
 	
 	vfs_file_t *file;
-	rc = vfs_fd_alloc(&file, false, out_fd);
-	if (rc != EOK) {
+	int fd = vfs_fd_alloc(&file, false);
+	if (fd < 0) {
 		vfs_node_put(node);
 		vfs_file_put(parent);
-		return rc;
+		return fd;
 	}
 	assert(file != NULL);
@@ -908,8 +910,9 @@
 	fibril_rwlock_read_unlock(&namespace_rwlock);
 
+	*out_fd = fd;
 	return EOK;
 }
 
-errno_t vfs_op_write(int fd, aoff64_t pos, size_t *out_bytes)
+int vfs_op_write(int fd, aoff64_t pos, size_t *out_bytes)
 {
 	return vfs_rdwr(fd, pos, false, rdwr_ipc_client, out_bytes);
Index: uspace/srv/vfs/vfs_pager.c
===================================================================
--- uspace/srv/vfs/vfs_pager.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/vfs/vfs_pager.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,5 +48,5 @@
 	int fd = IPC_GET_ARG3(*request);
 	void *page;
-	errno_t rc;
+	int rc;
 
 	page = as_area_create(AS_AREA_ANY, page_size,
Index: uspace/srv/vfs/vfs_register.c
===================================================================
--- uspace/srv/vfs/vfs_register.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/vfs/vfs_register.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -118,5 +118,5 @@
 	
 	vfs_info_t *vfs_info;
-	errno_t rc = async_data_write_accept((void **) &vfs_info, false,
+	int rc = async_data_write_accept((void **) &vfs_info, false,
 	    sizeof(vfs_info_t), sizeof(vfs_info_t), 0, NULL);
 	
@@ -346,7 +346,7 @@
  *                vfs_fstypes_free().
  *
- * @return EOK on success or an error code
- */
-errno_t vfs_get_fstypes(vfs_fstypes_t *fstypes)
+ * @return EOK on success or negative error code
+ */
+int vfs_get_fstypes(vfs_fstypes_t *fstypes)
 {
 	size_t size;
